//---------------------------------------------------------------------------

#include <vcl.h>

#pragma hdrstop

#include "FlashingLabel.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TFlashingLabel *)
{
    new TFlashingLabel(NULL);
}
//---------------------------------------------------------------------------
__fastcall TFlashingLabel::TFlashingLabel(TComponent* Owner)
    : TLabel(Owner)
{
    FFlashEnabled = true;
    FFlashRate = 800;
    FColorFlashRate = 800;
    FontColor = this->Font->Color;
    FColorFlash = false;
    Timer = new TTimer(this);
    Timer->Interval = FlashRate;
    Timer->OnTimer = &OnTimer;
    //Sleep(FFlashRate/2);
    ColorTimer = new TTimer(this);
    ColorTimer->Enabled = false;
    ColorTimer->Interval = FlashRate;
    ColorTimer->OnTimer = &OnColorTimer;
}
//---------------------------------------------------------------------------
void __fastcall TFlashingLabel::SetFlashEnabled(bool AFlashEnabled){
    FFlashEnabled = AFlashEnabled;

    if(ComponentState.Contains( csDesigning))
        return;

    Timer->Enabled = FFlashEnabled;

    if(!FFlashEnabled)
        Visible = true;
}
//---------------------------------------------------------------------------
void __fastcall TFlashingLabel::SetColorFlash(bool AColorFlash){
    FColorFlash = AColorFlash;

    if(ComponentState.Contains( csDesigning))
        return;

    ColorTimer->Enabled = FColorFlash;

    if(!FColorFlash)
        this->Font->Color = FontColor;
}
//---------------------------------------------------------------------------
void __fastcall TFlashingLabel::SetFlashRate(int AFlashRate){
    Timer->Interval = FFlashRate = AFlashRate;
}
//---------------------------------------------------------------------------
void __fastcall TFlashingLabel::SetColorFlashRate(int AColorFlashRate){
    ColorTimer->Interval = FColorFlashRate = AColorFlashRate;
}
//---------------------------------------------------------------------------
void __fastcall TFlashingLabel::OnTimer(TObject* Sender){
    if(ComponentState.Contains(csDesigning)){
        Timer->Enabled = false;
        return;
    }

    Visible = !Visible;
}
//---------------------------------------------------------------------------
void __fastcall TFlashingLabel::OnColorTimer(TObject* Sender){
    if(ComponentState.Contains(csDesigning)){
        ColorTimer->Enabled = false;
        return;
    }

    if(this->Font->Color != FontColor){
        this->Font->Color = FontColor;
    }
    else{
        this->Font->Color = this->Color;
    }
}
//---------------------------------------------------------------------------
namespace Flashinglabel
{
    void __fastcall PACKAGE Register()
    {
         TComponentClass classes[2] = {__classid(TFlashingLabel)};
         RegisterComponents("Odenbakh", classes, 0);
    }
}
//---------------------------------------------------------------------------
 
