//---------------------------------------------------------------------------

#ifndef FlashingLabelH
#define FlashingLabelH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
//---------------------------------------------------------------------------
class PACKAGE TFlashingLabel : public TLabel
{
private:
    bool FFlashEnabled;
    bool FColorFlash;
    TColor FontColor;
    int FFlashRate;
    int FColorFlashRate;
    TTimer* Timer;
    TTimer* ColorTimer;
protected:
    void __fastcall SetFlashEnabled(bool AFlashEnabled);
    void __fastcall SetColorFlash(bool AColorFlash);
    void __fastcall SetFlashRate(int AFlashRate);
    void __fastcall SetColorFlashRate(int AColorFlashRate);
    void __fastcall OnTimer(TObject* Sender);
    void __fastcall OnColorTimer(TObject* Sender);
public:
    __fastcall virtual TFlashingLabel(TComponent* Owner);
__published:
    __property bool FlashEnabled =
                    {read=FFlashEnabled, write=SetFlashEnabled, default=true};
    __property bool ColorFlashEnabled =
                    {read=FColorFlash, write=SetColorFlash, default=false};
    __property int FlashRate =
                   {read=FFlashRate, write=SetFlashRate, default=800};
    __property int ColorFlashRate =
                   {read=FColorFlashRate, write=SetColorFlashRate, default=800};
};
//---------------------------------------------------------------------------
#endif
