//---------------------------------------------------------------------------
#include <vcl.h>
#include <windows.h>
#pragma hdrstop
#include "NumericEdit.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
static inline void ValidCtrCheck(TNumericEdit *)
{
    new TNumericEdit(NULL);
}
//---------------------------------------------------------------------------
__fastcall TNumericEdit::TNumericEdit(TComponent* Owner)
    : TEdit(Owner)
{
    
    FAllowNegative = false;
    FAllowDecimal = false;
    char Buf[1];
    GetLocaleInfo(LOCALE_USER_DEFAULT,LOCALE_SDECIMAL,Buf,2);
    FDecimalSeparator = *Buf;
    //FDecimalSeparator = ',';
    FSeparatorType = InSystem;
    this->Text = "0";

}
//---------------------------------------------------------------------------

void __fastcall TNumericEdit::KeyPress(char &Key){

    if(FAllowNegative){
        if(Key=='-'){
            //this->Text = IntToStr(StrToInt(this->Text)*(-1));
            if(this->Text.AnsiPos("-")==0){
                this->Text = "-" + this->Text;
            }
            else{
                this->Text = this->Text.SubString(2,this->Text.Length());
            }
            
            SendMessage(this->Handle,WM_KEYDOWN,VK_END,NULL);
            SendMessage(this->Handle,WM_KEYUP,VK_END,NULL);
            
            Key=0;
            return ;
        }
    }
    if(FAllowDecimal){

        if(Key=='\.' || Key==','){
            if(this->Text.AnsiPos(FDecimalSeparator)==0){
                Key = FDecimalSeparator;
            }
            else{
                Key=0;
                return;
            }
        }
        if((this->Text.IsEmpty() || this->Text.Length() == this->SelLength)
            && Key==FDecimalSeparator){
            this->Text = "0";
            SendMessage(this->Handle,WM_KEYDOWN,VK_RIGHT,NULL);
            SendMessage(this->Handle,WM_KEYUP,VK_RIGHT,NULL);
        }
        if(this->Text=="-" && Key==FDecimalSeparator){
            this->Text ="-0";
            SendMessage(this->Handle,WM_KEYDOWN,VK_END,NULL);
            SendMessage(this->Handle,WM_KEYUP,VK_END,NULL);

        }
    }
    else{
        if(Key==FDecimalSeparator){
            Key=0;
            return;
        }
    }
    if((Key<'0' || Key>'9') && Key!='\b' && Key!=FDecimalSeparator){
        Key = 0;
        return;
    }
    TEdit::KeyPress(Key);
}
//---------------------------------------------------------------------------
void __fastcall TNumericEdit::SetAllowNegativeEnabled(bool AAllowNegative){
    FAllowNegative = AAllowNegative;
    if(this->Text == ""){
        return;
    }
    if(!AAllowNegative){
        if(this->Text.AnsiPos("-")!=0){
            this->Text = this->Text.SubString(2,this->Text.Length());
            for(int i = 0; i<this->Text.Length();i++){
                SendMessage(this->Handle,WM_KEYDOWN,VK_RIGHT,NULL);
                SendMessage(this->Handle,WM_KEYUP,VK_RIGHT,NULL);
            }
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TNumericEdit::SetAllowDecimalEnabled(bool AAllowDecimal){
    FAllowDecimal = AAllowDecimal;
    //     ,   ,     
    if(!AAllowDecimal){
        int Pos = this->Text.AnsiPos(FDecimalSeparator);
        if(Pos!=0){
            this->Text = this->Text.SubString(0,Pos-1);
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TNumericEdit::SetSeparatorType(TSepType ASeparatorType){
    if(ASeparatorType==InSystem){
        char Buf[1];
        GetLocaleInfo(LOCALE_USER_DEFAULT,LOCALE_SDECIMAL,Buf,2);
        if(FDecimalSeparator!=*Buf){
            int Pos = this->Text.AnsiPos(FDecimalSeparator);
            if(Pos!=0){
                this->Text = this->Text.Delete(Pos,1);
                this->Text = this->Text.Insert(Buf,Pos);
            }
            FDecimalSeparator = *Buf;
        }
    }
    FSeparatorType = ASeparatorType;

}
//---------------------------------------------------------------------------
void __fastcall TNumericEdit::SetDecimalSeparator(char ADecimalSeparator){
    if(FSeparatorType==InSystem){
        return;
    }
    FDecimalSeparator = ADecimalSeparator;

}
//---------------------------------------------------------------------------
namespace Numericedit
{
    void __fastcall PACKAGE Register()
    {
         TComponentClass classes[3] = {__classid(TNumericEdit)};
         RegisterComponents("Odenbakh", classes, 0);
    }
}
//---------------------------------------------------------------------------
