//---------------------------------------------------------------------------

#ifndef NumericEditH
#define NumericEditH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
//---------------------------------------------------------------------------
enum TSepType {InSystem,UserDefined};
//---------------------------------------------------------------------------
class PACKAGE TNumericEdit : public TEdit
{
private:
    bool FAllowNegative;
    bool FAllowDecimal;
    TSepType FSeparatorType;
    char FDecimalSeparator;


protected:
    void __fastcall SetAllowNegativeEnabled(bool AAllowNegative);
    void __fastcall SetAllowDecimalEnabled(bool AAllowDecimal);
    void __fastcall SetSeparatorType(TSepType ASeparatorType);
    void __fastcall SetDecimalSeparator(char ADecimalSeparator);

public:

    __fastcall TNumericEdit(TComponent* Owner);
    DYNAMIC void __fastcall KeyPress(char &Key);

__published:
    __property bool AllowNegative = {read=FAllowNegative,write=SetAllowNegativeEnabled,default=false};
    __property bool AllowDecimal = {read=FAllowDecimal,write=SetAllowDecimalEnabled,default=false};
    __property TSepType SeparatorType = {read=FSeparatorType,write=SetSeparatorType,default=InSystem};
    __property char DecimalSeparator = {read=FDecimalSeparator,write=SetDecimalSeparator,default=','};

};
//---------------------------------------------------------------------------
#endif
